Как запустить PHP7.0-fpm - нет такого процесса, ошибка 502 и в логах connect() to unix:/var/run/php7.0-fpm.sock failed (111: Connection refused)

Аватар пользователя tlito

поставил на Debian 8 сервер Nginx + PHP7 + PHP7.0-FPM, статика работает, а обращение к php-файлам даёт ошибку 502.
почитав /var/log/nginx/site.com.error.log я понял что ошибка с сокетом:

2016/08/19 05:05:32 [error] 1392#1392: *15 connect() to unix:/var/run/php7.0-fpm.sock failed (111: Connection refused) while connecting to upstream, client: 88.88.88.88, server: site.com, request: "GET /index.php HTTP/1.1", upstream: "fastcgi://unix:/var/run/php7.0-fpm.sock:", host: "site.com"

но в интернете пояснили, что возможно не запущен процесс обработки запросов, то есть php7.0-fpm, я проверил так и убедился что пхп-фпм не запускается:

# whereis php7.0-fpm
php7: /usr/bin/php7.0 /usr/local/php7 /usr/share/php7.0-json /usr/share/php7.0-common /usr/share/php7.0-gd /usr/share/php7.0-opcache /usr/share/php7.0-curl /usr/share/php7.0-mysql /usr/share/php7.0-readline /usr/src/php-7.0.2/php7.spec
# service php7.0-fpm start
# ps -aux |grep php7
root      3180  0.0  0.4  13948  2084 pts/0    S+   13:36   0:00 grep php7
#

почему не запущен php7.0-fpm или я неправильно проверяю?
подскажите, как справиться с ошибкой и запускать пхп-сайты на nginx + php7-fpm ?

Ключевые слова:
Тип материала:
Версия Drupal:
0 Спасибо

Лучший ответ

Аватар пользователя Mihail.space
Mihail.space 1 год назад 1

если у тебя сайты не в папке www по дефолту, то нужен свой пул на домен к примеру /etc/php/7.0/fpm/pool.d/example.ru.conf
А вообще странно, что у тебя завелось на php5 , но не заводится на php7. Там разница в настройке только в путях к конфигам.
http://kubanga.ru/obnovlenie-php-56-do-php-7-v-debian-jessie-na-vds-digitalocean-php-7-nginx-postgresql-dla-drupal-8

Комментарии

Аватар пользователя tlito
tlito 1 год назад

может поиск процесса неправильный. вот так что-то видно

# ps  -aux | grep php
root      1398  0.0  5.1 263560 26284 ?        Ss   05:03   0:02 php-fpm: master process (/etc/php/7.0/fpm/php-fpm.conf)                      
www-data  1400  0.0  1.1 263560  5900 ?        S    05:03   0:00 php-fpm: pool www                                                            
www-data  1401  0.0  1.1 263560  5900 ?        S    05:03   0:00 php-fpm: pool www                                                            
root     11714  0.0  0.4  13948  2104 pts/0    S+   14:10   0:00 grep php
0 Спасибо
Аватар пользователя tlito
tlito 1 год назад

вот код /etc/init.d/php7-fpm

# cat php7-fpm
#!/bin/sh
### BEGIN INIT INFO
# Provides:          php-fpm php7-fpm
# Required-Start:    $remote_fs $network
# Required-Stop:     $remote_fs $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: starts php7-fpm
# Description:       Starts The PHP FastCGI Process Manager Daemon
### END INIT INFO

# Author: Ondrej Sury <o...j@de...n.o..g>
# Adapted to php7-fpm by @b..joh..en

PATH=/usr/local/php7/sbin:/sbin:/usr/sbin:/bin:/usr/bin
DESC="PHP7 FastCGI Process Manager"
NAME=php-fpm
DAEMON=/usr/sbin/$NAME
DAEMON_ARGS="--daemonize --fpm-config /usr/local/php7/etc/php-fpm.conf"
PIDFILE=/var/run/php7-fpm.pid
TIMEOUT=30
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

# Don't run if we are running upstart
if init_is_upstart; then
    exit 1
fi

#
# Function to check the correctness of the config file
#
do_check()
{
    /usr/local/lib/php7-fpm-checkconf || return 1
    return 0
}

#
# Function that starts the daemon/service
#
do_start()
{
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
                || return 1
        start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
                $DAEMON_ARGS 2>/dev/null \
                || return 2
        # Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
                # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon --stop --quiet --retry=QUIT/$TIMEOUT/TERM/5/KILL/5 --pidfile $PIDFILE --name $NAME
        RETVAL="$?"
        [ "$RETVAL" = 2 ] && return 2
        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.
        start-stop-daemon --stop --quiet --oknodo --retry=0/30/TERM/5/KILL/5 --exec $DAEMON
        [ "$?" = 2 ] && return 2
        # Many daemons don't delete their pidfiles when they exit.
        rm -f $PIDFILE
        return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        #
        # If the daemon can reload its configuration without
        # restarting (for example, when it is sent a SIGHUP),
        # then implement that here.
        #
        start-stop-daemon --stop --signal USR2 --quiet --pidfile $PIDFILE --name $NAME
        return 0
}

case "$1" in
    start)
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        do_check $VERBOSE
        case "$?" in
            0)
                do_start
                case "$?" in
                    0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                    2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
                esac
                ;;
            1) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
    stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        do_stop
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
    status)
        status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
        ;;
    check)
        do_check yes
        ;;
    reload|force-reload)
        log_daemon_msg "Reloading $DESC" "$NAME"
        do_reload
        log_end_msg $?
        ;;
    reopen-logs)
        log_daemon_msg "Reopening $DESC logs" $NAME
        if start-stop-daemon --stop --signal USR1 --oknodo --quiet \
            --pidfile $PIDFILE --exec $DAEMON
        then
            log_end_msg 0
        else
            log_end_msg 1
        fi
        ;;
    restart)
        log_daemon_msg "Restarting $DESC" "$NAME"
        do_stop
        case "$?" in
          0|1)
                do_start
                case "$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
          *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
    *)
        echo "Usage: $SCRIPTNAME {start|stop|status|restart|reload|force-reload}" >&2
        exit 1
    ;;
esac

0 Спасибо
Аватар пользователя Mihail.space
Mihail.space 1 год назад 1

pool настраивали?
По правде говоря у меня с сокетом тоже траблы были и было лень разбираться и запускал через tcp
В бложике есть устаревший материал, но настройки fpm и пула там в принципе актуальны.

Аватар пользователя tlito
tlito 1 год назад

pool не упоминался в мануалах, я не знаю что это такое

0 Спасибо
Аватар пользователя tlito
tlito 1 год назад

вот как настроена связка Nginx + php7.0-fpm

# cat /etc/nginx/fastcgi_params

fastcgi_pass    unix:/var/run/php7.0-fpm.sock;
fastcgi_index   index.php;
 fastcgi_split_path_info                ^(.+\.php)(/.+)$;
....

# cat /usr/local/php7/etc/php-fpm.d/php-fpm.conf
[global]
 
pid = /var/run/php7-fpm.pid
error_log = /var/log/php7-fpm.log

include=/usr/local/php7/etc/php-fpm.d/*.conf

# cat /usr/local/php7/etc/php-fpm.d/www.conf
[www]
user = www-data
group = www-data
 
listen = /var/run/php7.0-fpm.sock
listen.owner = www-data
listen.group = www-data
listen.mode = 0660
 
pm = dynamic
pm.max_children = 5
pm.start_servers = 2
pm.min_spare_servers = 1
pm.max_spare_servers = 3

вот конфиг хоста site.com

# cat /etc/nginx/sites-available/site.com
server {
    listen                  80;
    server_name             site.com *.site.com;
 
    set                     $main_host          'site.com';
 
    if ($host != $main_host) {
        rewrite             ^(.*)$              http://$main_host$1     permanent;
        break;
    }
 
    access_log              /var/log/nginx/site.com.access.log       main;
    error_log               /var/log/nginx/site.com.error.log;
 
    root                    /var/www/$main_host/www;
    index                   index.php;
 
 
    location / {
        try_files           $uri    $uri/    /index.php?$args;
    }  
 
    location ~ \.php$ {
        fastcgi_split_path_info ^(.+\.php)(/.+)$;
        include             /etc/nginx/fastcgi_params;
 
        fastcgi_param       SCRIPT_FILENAME     /var/www/$main_host/www$fastcgi_script_name;
        fastcgi_param       DOCUMENT_ROOT       /var/www/$main_host/www;
 
    }
 
    location ~ /\. {
        deny                all;
        access_log          off;
        log_not_found       off;
    }
}
0 Спасибо
Аватар пользователя tlito
tlito 1 год назад

да, как я теперь понимаю pool в php7.0-fpm описан тут /usr/local/php7/etc/php-fpm.d/www.conf.default - я его правил в двух местах, где-то что-то читав без понятия, теперь, когда я понимаю что значит php7-fpm "слушает" я вижу что тут ошибка:

cat /usr/local/php7/etc/php-fpm.d/www.conf.default
...
listen = 127.0.0.1:9000
...

в этом файле я эту строку правил и еще по-моему одну из эти раскомментировал:
user = www-data
group = www-data

ну теперь я исправил слушать сокет:
listen = /var/run/php7.0-fpm.sock

права у него такие (666, отличаются от задаваемых где-то 0660)
# ls -l /var/run/php7.0-fpm.sock
-rw-rw-rw- 1 www-data www-data 0 Aug 20 05:05 /var/run/php7.0-fpm.sock

рестарт сервиса
service php7-fpm restart

не помогло. ошибка:

tail /var/log/nginx/site.com.error.log
2016/08/20 14:47:04 [error] 1392#1392: *56 connect() to unix:/var/run/php7.0-fpm.sock failed (111: Connection refused) while connecting to upstream, client: 88.88.88.88, server: aaa.com, request: "GET /favicon.ico HTTP/1.1", upstream: "fastcgi://unix:/var/run/php7.0-fpm.sock:", host: "site.com", referrer: "http://site.com/"
0 Спасибо
Аватар пользователя tlito
tlito 1 год назад

ПРОБЛЕМ НЕ РЕШИЛАСЬ

снёс php7 со всеми зависимостями, и php тоже снес так
apt-get purge php7
apt-get remove php*

и поставил php5-fpm одной строкой из одного мануала на моем сайте.
подкорректировал /etc/nginx/fastcgi_params (изменив адрес сокета на /var/run/php5-fpm.sock),
и сайт нормально стал работать

0 Спасибо
Аватар пользователя Mihail.space
Mihail.space 1 год назад 1

если у тебя сайты не в папке www по дефолту, то нужен свой пул на домен к примеру /etc/php/7.0/fpm/pool.d/example.ru.conf
А вообще странно, что у тебя завелось на php5 , но не заводится на php7. Там разница в настройке только в путях к конфигам.
http://kubanga.ru/obnovlenie-php-56-do-php-7-v-debian-jessie-na-vds-digitalocean-php-7-nginx-postgresql-dla-drupal-8

Аватар пользователя tlito
tlito 1 год назад

спасибо за ссылку. пытаюсь заново на новой впсине.
вообще меня смущала и сейчас опять появляется следующая проблема:

после запуска команды автора http://kubanga.ru/obnovlenie-php-56-do-php-7-v-debian-jessie-na-vds-digitalocean-php-7-nginx-postgresql-dla-drupal-8
«Устанавливаем php7
apt-get install php7.0-fpm php7.0-gd php7.0-pgsql php7.0-apcu php7.0-curl»

все ставится но в конце вот что сообщвет:

Creating config file /etc/php/7.0/mods-available/pdo_pgsql.ini with new version
Processing triggers for libc-bin (2.19-18+deb8u4) ...
Processing triggers for systemd (215-17+deb8u4) ...
Processing triggers for php7.0-fpm (7.0.10-1~dotdeb+8.1) ...
W: Duplicate sources.list entry http://packages.dotdeb.org/ jessie/all amd64 Packages (/var/lib/apt/lists/packages.dotdeb.org_dists_jessie_all_binary-amd64_Packages)
W: You may want to run apt-get update to correct these problems

но ввсе вроде есть, просто вопрос сконфигурировано ли?

# whereis php7.0    
php7: /usr/bin/php7.0 /usr/share/php7.0-pgsql /usr/share/php7.0-gd /usr/share/php7.0-json /usr/share/php7.0-common /usr/share/php7.0-curl /usr/share/php7.0-readline /usr/share/php7.0-opcache
0 Спасибо
Аватар пользователя Mihail.space
Mihail.space 1 год назад

php7.0-pgsql нужно, если базой данных используется postgresq и для неё еще нужно установить саму postgresql - apt-get install postgresql
, в записи про это ничего нет, так как писалось уже поверх установленной.
В конце консоль сообщила о дублировании и предложила обновить синхронизацию пакетов с репозиториями через apt-get update.
Консоль если русифицировать, то читать ее комментарии при выводе будет проще.
Хотя, если через putty работаешь с удаленной машиной, то не знаю как с этим помочь)

0 Спасибо
Аватар пользователя tlito
tlito 1 год назад

хорошо. спасибо. но у меня не запускается php7.0-fpm и в журнале ошибка - не может подключить пул, который я просто продублировал с указанной страницы:

# cat /etc/php/7.0/fpm/pool.d/sait.ru.conf
[sait.ru]
user = master
group = www-data
listen = 127.0.0.1:9001
pm = dynamic pm.max_children = 5
pm.start_servers = 2
pm.min_spare_servers = 1
pm.max_spare_servers = 3
pm.max_requests = 1500
security.limit_extensions = .php
php_admin_value[error_log] = /home/master/domains/sait.ru/logs/fpm-php.www.error.log  
php_admin_flag[log_errors] = on
php_admin_value[memory_limit] = 256M
php_admin_value[open_basedir] = "/home/master:."/etc/init.d/nginx restart
php_admin_value[upload_tmp_dir] = "/home/master/tmp" php_admin_value[session.save_path] = "/home/master/tmp"

что тут не так? пользователя я создал. группу ему дал

# cat /etc/group |grep master
www-data:x:33:master
master:x:1000:
0 Спасибо
Аватар пользователя tlito
tlito 1 год назад

вот что пишет

# service php7.0-fpm restart && /etc/init.d/nginx restart

Job for php7.0-fpm.service failed. See 'systemctl status php7.0-fpm.service' and 'journalctl -sa' for details.

root@mach:/etc/php/7.0/fpm/pool.d# journalctl -sa
-- Logs begin at Mon 2016-08-22 05:01:02 EDT, end at Mon 2016-08-22 14:17:14 EDT. --
Aug 22 14:17:14 vds systemd[1]: Starting The PHP 7.0 FastCGI Process Manager...
-- Subject: Unit php7.0-fpm.service has begun with start-up
-- Defined-By: systemd
-- Support: http://lists.freedesktop.org/mailman/listinfo/systemd-devel
--
-- Unit php7.0-fpm.service has begun starting up.
Aug 22 14:17:14 vds systemd[1]: Failed to reset devices.list on /system.slice/php7.0-fpm.service: No such fi
le or directory
Aug 22 14:17:14 vds php-fpm7.0[17291]: [22-Aug-2016 14:17:14] ERROR: [/etc/php/7.0/fpm/pool.d/sait.ru.conf:5]
unable to parse value for entry 'pm': invalid process manager (static, dynamic or ondemand)
Aug 22 14:17:14 vds php-fpm7.0[17291]: PHP:  syntax error, unexpected '=' in Unknown on line 1
Aug 22 14:17:14 vds php-fpm7.0[17291]: [22-Aug-2016 14:17:14] ERROR: Unable to include /etc/php/7.0/fpm/pool.d/sait.ru.conf
from /etc/php/7.0/fpm/php-fpm.conf at line 5
Aug 22 14:17:14 vds php-fpm7.0[17291]: [22-Aug-2016 14:17:14] ERROR: failed to load configuration file '/etc/php/7
.0/fpm/php-fpm.conf'

Aug 22 14:17:14 vds php-fpm7.0[17291]: [22-Aug-2016 14:17:14] ERROR: FPM initialization failed
Aug 22 14:17:14 vds systemd[1]: php7.0-fpm.service: main process exited, code=exited, status=78/n/a
Aug 22 14:17:14 vds systemd[1]: Failed to start The PHP 7.0 FastCGI Process Manager.
-- Subject: Unit php7.0-fpm.service has failed
-- Defined-By: systemd
-- Support: http://lists.freedesktop.org/mailman/listinfo/systemd-devel
--
-- Unit php7.0-fpm.service has failed.
--
-- The result is failed.
Aug 22 14:17:14 vds systemd[1]: Unit php7.0-fpm.service entered failed state.

0 Спасибо
Аватар пользователя tlito
tlito 1 год назад

извиняюсь, просто у автора строки копируются в одну, и пришлось вставлять отступы строк правильно.
у него там и apcu.ini странно написан - в имени файла apcu а в конфигурации apc - я так и не понял надо u или не надо

0 Спасибо
Аватар пользователя Mihail.space
Mihail.space 1 год назад

в смысле в одну? я проверял, скопированные строки вставлял в sublime и с пробелами было все нормально.
в debian 7 был apc, а в debian8 apcu
в конфигурации apc
Когда с седьмого дебиана на восьмой переходил было неожиданностью)

0 Спасибо
Аватар пользователя tlito
tlito 1 год назад

после установки сервера по неполной инструкции, я увидел ошибку

The website encountered an unexpected error. Please try again later.

просмотрев логи ошибок nginx (файл ошибок сайта не был прописан в хосте, поэтому именно нгиникс):

# tail /var/log/nginx/error.log
..PHP message: Error: Undefined class constant 'MYSQL_ATTR_USE_BUFFERED_QUERY' in core/lib/Drupal/Core/Database/Driver/mysql/Connection.php..

я стал гуглить и понял, что надо доставить пакеты работы php7.0-fpm с базами mysql:

apt-get install php7.0-mysql php7.0-curl php7.0-redis php7.0-gd
service php7.0-fpm restart && /etc/init.d/nginx restart

после установки модулей для работы с бд, я опять увидел то же сообщение и в ошибках нгиникс были новые ошибки:

PHP message: Error: Class 'DOMDocument' not found in core/lib/Drupal/Component/Utility/Html.php on line 284

это предполагает установку php7.0-xml как я понял

apt-get install php7.0-cli php7.0-curl php7.0-fpm php7.0-gd php7.0-xml php7.0-mysql php7.0-mcrypt php7.0-opcache -y
service php7.0-fpm restart && /etc/init.d/nginx restart

после всех этих действий мой сайт открылся на Debian 8 Nginx + PHP7.0-FPM + mysql
спасибо михаил.спейс за рабочий мануал

0 Спасибо